//#version 120 //attribute
//precision highp float;
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureFgFBO;
uniform sampler2D fTextureMask;
uniform vec4 selectMaskColor;//点击位的mask颜色
uniform vec4 selectPaltColor;//调色盘颜色

bool isEques(const vec4 colorOne, const vec4 colorTwo);

void main() {
    gl_FragColor = texture2D(fTextureFgFBO, aFBOTextureCoord);
    vec4 maskColor = texture2D(fTextureMask, aCoordinate);
    if (isEques(maskColor, selectMaskColor)){
        gl_FragColor = vec4(selectPaltColor.r, selectPaltColor.g, selectPaltColor.b, 1.0);
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
    //    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
    //    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}
