//#version 120 //attribute
//precision highp float;
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureFgFBO;
uniform sampler2D fTextureMask;
uniform sampler2D fTextureTiezhi;
uniform vec4 selectMaskColor;//点击位的mask颜色
uniform vec4 curBgColor;//闪粉的背景色

bool isEques(const vec4 colorOne, const vec4 colorTwo);
vec4 mixcolor(vec4 bottom, vec4 top);
void main() {
    gl_FragColor = texture2D(fTextureFgFBO, aFBOTextureCoord);
    vec4 maskColor = texture2D(fTextureMask, aCoordinate);
    if (isEques(maskColor, selectMaskColor)){

        vec4 tiezhiColor = texture2D(fTextureTiezhi, aCoordinate);
        vec4 mixRgba =  mixcolor(curBgColor, tiezhiColor);
        gl_FragColor = vec4(mixRgba.r, mixRgba.g, mixRgba.b, 1.0);
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
    //    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
    //    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}


vec4 mixcolor(vec4 bottom, vec4 top){
    return vec4(
    top.r*(top.a)+bottom.r,
    top.g*(top.a)+bottom.g,
    top.b*(top.a)+bottom.b, 1.0);
}
