//#version 120 //attribute
precision mediump float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureParticleFBO;
uniform sampler2D fTextureMask;
uniform vec4 selectMaskColor;//点击位的mask颜色
uniform vec4 gStartColor;//渐变开始颜色
uniform vec4 gEndColor;//渐变开结束颜色

bool isEques(const vec4 colorOne, const vec4 colorTwo);

void main() {
    gl_FragColor = vec4(0, 0, 0, 0);
    if (selectMaskColor.a != 0.0){
        vec4 maskColor = texture2D(fTextureMask, aCoordinate);
        if (isEques(maskColor, selectMaskColor)){
            vec4 rgba = texture2D(fTextureParticleFBO, aFBOTextureCoord);
            vec4 rgbaUse =  mix(gStartColor, gEndColor, 2.0*distance(aCoordinate, vec2(0.5, 0.5)));
            gl_FragColor = vec4(rgbaUse.r, rgbaUse.g, rgbaUse.b, rgba.a);
            if (rgba.a == 0.0){
                discard;
            }
        }
    } else {
        vec4 rgba = texture2D(fTextureParticleFBO, aFBOTextureCoord);
        vec4 rgbaUse =  mix(gStartColor, gEndColor, 2.0*distance(aCoordinate, vec2(0.5, 0.5)));
        gl_FragColor = vec4(rgbaUse.r, rgbaUse.g, rgbaUse.b, rgba.a);
        if (rgba.a == 0.0){
            discard;
        }
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
    //    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
    //    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}