//#version 120 //attribute
precision highp float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureMask;
uniform sampler2D fTextureShanfeng;

uniform vec4 selectMaskColor;//点击位的mask颜色

bool isEques(const vec4 colorOne, const vec4 colorTwo);

void main() {
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    vec4 rgbaShanfeng = texture2D(fTextureShanfeng, aCoordinate);
    gl_FragColor = vec4(0, 0, 0, 0);
    if (isEques(rgba, selectMaskColor)){
        gl_FragColor = vec4(rgbaShanfeng.r, rgbaShanfeng.g, rgbaShanfeng.b, rgbaShanfeng.a);
    }
}

bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
    //    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
    //    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}
