//#version 120 //attribute
precision highp float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureMask;
uniform sampler2D fTextureWhiteFBO;
uniform sampler2D fTextureWhiteOrg;
uniform sampler2D fTextureShanfeng;

uniform int useWhiteFBO;//是否使用 白色中间层的FBO 2标识重置
uniform int useShanfeng;//是否使用 白色中间层的FBO 2标识重置
//uniform vec4 drawColor;

uniform vec4 selectMaskColor;//点击位的mask颜色
uniform vec4 gStartColor;//渐变开始颜色
uniform vec4 gEndColor;//渐变开结束颜色
vec4 mixcolor(vec4 bottom, vec4 top, float topAlpha);
bool isEques(const vec4 colorOne, const vec4 colorTwo);
vec4 changeColor(vec4 originColor, vec4 drawColor);

void main() {
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    gl_FragColor = vec4(1, 1, 1, 1);
    if (useWhiteFBO == 1) {
        gl_FragColor = texture2D(fTextureWhiteFBO, aFBOTextureCoord);
    }
    if (isEques(rgba, selectMaskColor)){
        vec4 originColor = texture2D(fTextureWhiteOrg, aCoordinate);
        vec4 start =   changeColor(originColor, gStartColor);
        vec4 end =   changeColor(originColor, gEndColor);

        vec4 rgbaUse =  mix(start, end, 2.0*distance(aCoordinate, vec2(0.5, 0.5)));
        //        vec4 rgbaUse = start;
        if (useShanfeng == 1){

            highp float dw = 1.0/8.0;
            highp float dh = 1.0/8.0;
            highp float dx = (aCoordinate.x - floor(aCoordinate.x / dw) * dw)/dw;
            highp float dy = (aCoordinate.y - floor(aCoordinate.y / dh) * dh)/dh;
            vec2 dMosaicCoor = vec2(dx, dy);
            vec4 rgbaShanfeng = texture2D(fTextureShanfeng, dMosaicCoor);

            gl_FragColor = mixcolor(rgbaUse, rgbaShanfeng, 1.0);
        } else {
            gl_FragColor = vec4(rgbaUse.r, rgbaUse.g, rgbaUse.b, 1.0);
        }
        if (gStartColor.a == 0.0) {
            gl_FragColor = vec4(1, 1, 1, 1);
        }
    }
    if (useWhiteFBO == 2) {
        gl_FragColor = vec4(1, 1, 1, 1);
    }
}

vec4 mixcolor(vec4 bottom, vec4 top, float topAlpha){
    return vec4(
    top.r+bottom.r*(1.0-top.a * topAlpha),
    top.g+bottom.g*(1.0-top.a * topAlpha),
    top.b+bottom.b*(1.0-top.a * topAlpha),
    1.0);
}

vec4 changeColor(vec4 originColor, vec4 drawColor){
    highp float Y = (0.257 * originColor.r) + (0.504 * originColor.g) + (0.098 * originColor.b) + 16.0;
    highp float V = (0.439 * originColor.r) - (0.368 * originColor.g) - (0.071 * originColor.b) + 128.0;
    highp float U = -(0.148 * originColor.r) - (0.291 * originColor.g) + (0.439 * originColor.b) + 128.0;

    float Y1 = (0.257 * drawColor.r) + (0.504 * drawColor.g) + (0.098 * drawColor.b) + 16.0;
    U = -(0.148 * drawColor.r) - (0.291 * drawColor.g) + (0.439 * drawColor.b) + 128.0;
    V = (0.439 * drawColor.r) - (0.368 * drawColor.g) - (0.071 * drawColor.b) + 128.0;

    Y = Y1/(Y1 + Y) * Y + Y/(Y1 + Y) * Y1;

    highp float b = 1.164 * (Y - 16.0) + 2.018 * (U - 128.0);
    highp float g = 1.164 * (Y - 16.0) - 0.813 * (V - 128.0) - 0.391 * (U - 128.0);
    highp float r = 1.164 * (Y - 16.0) + 1.596 * (V - 128.0);

    return vec4(r, g, b, 1);
}
bool isEques(const vec4 colorOne, const vec4 colorTwo){
    float r = colorOne.r - colorTwo.r;
    float g = colorOne.g- colorTwo.g;
    //    float b = colorOne.b- colorTwo.b;
    //float a = colorOne.a- colorTwo.a;
    if ((r < dx && r> -dx)
    &&(g < dx && g> -dx)
    //    &&(b < dx && b> -dx)
    //    &&(a < dx && a> -dx)
    ){
        return true;
    } else {
        return false;
    }
}
